<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
>
  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [iconName]="iconNameEnum.disseminationPolicies"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #centerTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.name) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.nameLabel | translate}}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>
    <mat-form-field *ngIf="getFormControl(formDefinition.prefix) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.prefixLabel | translate}}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.downloadFileName) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.downloadFileNameLabel | translate}}</mat-label>
      <mat-select [formControl]="fd"
                  [required]="formValidationHelper.hasRequiredField(fd)"
                  [solidifyValidation]="errors"
      >
        <mat-option *ngFor="let type of disseminationPolicyDownloadFileNameEnumToTranslate"
                    [value]="type.key"
                    solidifyTooltipOnEllipsis
        >
          {{type.value | translate}}
        </mat-option>
      </mat-select>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.suffix) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.suffixLabel | translate}}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    @if (model | isNotNullNorUndefined) {
      @for (parameter of fieldsParameters; track parameter) {
        @if (parameter !== this.formDefinition.name) {
          <mat-form-field *ngIf="!hasTypeChanged && getFormParameterControl(parameter) as fd"
                          [appearance]="appearanceInputMaterial"
                          solidifyTooltipOnEllipsis
          >
            <mat-label>{{stringUtil.convertToSentence(parameter)}}</mat-label>
            <input [formControl]="fd"
                   [required]="formValidationHelper.hasRequiredField(fd)"
                   [solidifyValidation]="errors"
                   matInput
            >
            <mat-error #errors
                       solidifyTooltipOnEllipsis
            ></mat-error>
          </mat-form-field>
        }
      }
    }
  </ng-template>

  <ng-template #rightTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.type) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.type | translate}}</mat-label>
      <mat-select [formControl]="fd"
                  [required]="formValidationHelper.hasRequiredField(fd)"
                  [solidifyValidation]="errors"
      >
        <mat-option *ngFor="let type of disseminationPolicyTypeEnumToTranslate"
                    [value]="type.key"
                    solidifyTooltipOnEllipsis
        >
          {{type.value | translate}}
        </mat-option>
      </mat-select>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

  </ng-template>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
